unit ellipse;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg, Spin;

type
  TFrmMain = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Image1: TImage;
    Panel1: TPanel;
    Memo: TMemo;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    CheckBox: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button1KeyPress(Sender: TObject; var Key: Char);
    procedure SpinEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure SpinEdit2KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;
      x0,y0,xf,yf,x1,x2,x3,y1,y2,y3,xa,ya,fa,bx,by:real;
      p,q,c,aa,bb,cc,dd,dfi,eps:real;
      tx0,ty0,txf,tyf,tx1,tx2,tx3,ty1,ty2,ty3:integer;
      gd,gm,yy,xx,min,xx1,xx2,yy1,yy2,yy11,yy22:integer;
      path:string;
      ch:char;
      qqqq:boolean;
implementation

{$R *.DFM}

procedure x_to_tx(x,y:real;var tx,ty:integer);
var mm:integer;
  begin
    mm:=min div 2;
    tx:=trunc(x*mm)+mm;
    ty:=-trunc(y*mm)+mm;
  end;

procedure systemsolve(p,q,c:real;var x1,y1,x2,y2:real);
  begin
    if p=0
      then
        begin
          x1:=sqrt(abs(c*c/q/q-1));
          x2:=-x1;
          y1:=(c-p*x1)/q;
          y2:=(c-p*x2)/q
        end
      else
        begin
          if q=0
            then
              begin
                x1:=c/p;
                x2:=x1;
                y1:=sqrt(abs(1-x1*x1));
                y2:=-y1
              end
            else
              begin
                aa:=1+p*p/q/q;
                bb:=-2*c*p/q/q;
                cc:=c*c/q/q-1;
                dd:=bb*bb-4*aa*cc;
                x1:=(-bb-sqrt(dd))/2/aa;
                x2:=(-bb+sqrt(dd))/2/aa;
                y1:=(c-p*x1)/q;
                y2:=(c-p*x2)/q
              end
        end
  end;

procedure triangle(fa:real);
  begin
    xa:=cos(fa); ya:=sin(fa);
    bx:=(xf+xa)/2; by:=(yf+ya)/2;
    p:=xf-xa; q:=yf-ya;
    c:=p*bx+q*by;{  px+qy=c}
    systemsolve(p,q,c,x1,y1,x2,y2);
    x_to_tx(x1,y1,tx1,ty1);
    x_to_tx(x2,y2,tx2,ty2);
    frmmain.Canvas.MoveTo(tx1, ty1);
    frmmain.Canvas.LineTo(tx2,ty2);
    c:=-q*bx+p*by;
    systemsolve(-q,p,c,x1,y1,x2,y2);
    if (abs(xa-x1)<eps) and (abs(ya-y1)<eps)
      then
        begin
          x3:=x2;
          y3:=y2
        end
      else
        begin
          x3:=x1;
          y3:=y1
        end;
    x_to_tx(x3,y3,tx3,ty3);
    frmmain.Canvas.MoveTo(tx1, ty1);
    frmmain.Canvas.LineTo(tx3,ty3);
    frmmain.Canvas.MoveTo(tx2, ty2);

  frmmain.Canvas.LineTo(tx3,ty3);
  end;

procedure triangleIm(fa:real);
  begin
    xa:=cos(fa); ya:=sin(fa);
    bx:=(xf+xa)/2; by:=(yf+ya)/2;
    p:=xf-xa; q:=yf-ya;
    c:=p*bx+q*by;{  px+qy=c}
    systemsolve(p,q,c,x1,y1,x2,y2);
    x_to_tx(x1,y1,tx1,ty1);
    x_to_tx(x2,y2,tx2,ty2);
    frmmain.Image1.Canvas.MoveTo(tx1, ty1);
    frmmain.Image1.Canvas.LineTo(tx2,ty2);
    c:=-q*bx+p*by;
    systemsolve(-q,p,c,x1,y1,x2,y2);
    if (abs(xa-x1)<eps) and (abs(ya-y1)<eps)
      then
        begin
          x3:=x2;
          y3:=y2
        end
      else
        begin
          x3:=x1;
          y3:=y1
        end;
    x_to_tx(x3,y3,tx3,ty3);
    frmmain.Image1.Canvas.MoveTo(tx1, ty1);
    frmmain.Image1.Canvas.LineTo(tx3,ty3);
    frmmain.Image1.Canvas.MoveTo(tx2, ty2);

  frmmain.Image1.Canvas.LineTo(tx3,ty3);
  end;

procedure TFrmMain.Button1Click(Sender: TObject);
var sss:string;
    code,i:integer;
begin
   //image1.Visible:=false;
   //image1.Canvas.brush.Color:=clblue;
   //image1.Canvas.pen.Color:=clblue;
   //image1.Canvas.Rectangle(0,0,frmmain.Width,frmmain.Height);
   sss:=edit1.Text;
   for i:=1 to length(sss) do
     if sss[i]=',' then sss[i]:='.';
   val(sss,xf,code);
   if code <>0
     then xf:=0;
   eps:=1e-3;
   if abs(xf)>=1
     then xf:=0;
   if frmmain.Height<frmmain.Width
     then min:=frmmain.Height
     else min:=frmmain.Width;
   min:=min-40;
   Canvas.brush.color := clyellow;
   Canvas.Ellipse(0,0,min,min);
   x0:=0;y0:=0;
  {xf:=0.95;}
(*  yf:=0; {focus}*)
  x_to_tx(x0,y0,tx0,ty0);
  x_to_tx(xf,yf,txf,tyf);
  Canvas.Pixels[tx0,ty0]:=clblue;
  Canvas.Pixels[txf,tyf]:=clBlue;
  dfi:=0.001;
  fa:=0;
  xx:=(tx0+txf) div 2;
  yy:=(ty0+tyf) div 2;
  xx1:=xx-(min div 4);
  yy1:=trunc(yy-(min div 4)*sqrt(1-xf*xf));
  xx2:=xx+(min div 4);
  yy2:=trunc(yy+(min div 4)*sqrt(1-xf*xf));
  Canvas.brush.style:=bsclear;
  qqqq:=false;
  repeat
    Canvas.Pen.Color := clblue;
    triangle(fa);
    for i:=1 to 2000000 do;
    if checkbox.Checked
      then
        begin
          Canvas.Pen.Color := clyellow;
          triangle(fa);
        end;
    Canvas.Pen.Color := clgreen;
    canvas.ellipse(xx1,yy1,xx2,yy2);
    fa:=fa+dfi;
    Canvas.Pen.Color := clred;
    Canvas.Ellipse(0,0,min,min);
    {if fa>20*pi then fa:=0}
    Application.ProcessMessages;
  until (fa>2*pi)or(qqqq);
  yy11:=yy-(min div 4);
  yy22:=yy+(min div 4);
  with Image1 do begin
  //visible:=true;
  Canvas.Pen.Color:=clRed;
  Canvas.brush.color := clyellow;
  Canvas.Ellipse(0,0,min,min);
  // Canvas.pen.Width:=2;
  Canvas.pen.Color:=clBlue;
  canvas.Ellipse(xx1,yy1,xx2,yy2);
  triangleIm(0.99*pi);
  Canvas.Pen.Color:=clAqua;
  triangleIm(-1.5*pi);
  Canvas.pen.Color:=clPurple;
  triangleIm(-0.65*pi);
  Canvas.pen.Color:=clred;
  triangleIm(0);
  Canvas.pen.Color:=clGreen;
  Canvas.brush.style:=bsclear;
  canvas.Ellipse(xx1,yy11,xx2,yy22);
  Canvas.Pixels[tx0,ty0]:=clblue;
  Canvas.Pixels[txf,tyf]:=clBlue;
  sss:='F_'+Edit1.Text+'.bmp';
  Picture.SaveToFile(sss);
  end
end;

procedure TFrmMain.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if ord(key)=13 then  Button1.OnClick(Sender);
  if ord(key)=27 then  qqqq:=true;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
  var hh:string;
begin 
   hh:='      ,   , ';
   hh:=hh+'            , ';
   hh:=hh+'     ,      . ';
   hh:=hh+' ,       .  ';
   hh:=hh+'   -        . ';
   hh:=hh+'      -0,999  0,999 -      ';
   hh:=hh+'   .   0,      ';
   hh:=hh+'- .      0,      . ';
   hh:=hh+'     1,      .';
   hh:=hh+'       :    (   ) ';
   hh:=hh+'    ,      . ';
   memo.Text:=hh;
end;

procedure TFrmMain.SpinEdit1Change(Sender: TObject);
var tt:real;
    ww,ww1,code:integer;
    uu:string;
begin
  val(spinedit1.Text,ww,code);
  val(spinedit2.Text,ww1,code);
  tt:=ww/10+ww1/100;
  str(tt:2:2,uu);
  edit1.SetFocus;
  edit1.Text:=uu;  
end;

procedure TFrmMain.SpinEdit2Change(Sender: TObject);
var tt:real;
    ww,ww1,code:integer;
    uu:string;
begin
  val(spinedit1.Text,ww,code);
  val(spinedit2.Text,ww1,code);
  tt:=ww/10+ww1/100;
  str(tt:2:2,uu);
  edit1.SetFocus;
  edit1.Text:=uu;  
end;

procedure TFrmMain.FormKeyPress(Sender: TObject; var Key: Char);
begin
   if ord(key)=27 then  qqqq:=true;
end;

procedure TFrmMain.Button1KeyPress(Sender: TObject; var Key: Char);
begin
   if ord(key)=27 then  qqqq:=true;
end;

procedure TFrmMain.SpinEdit1KeyPress(Sender: TObject; var Key: Char);
begin
   if ord(key)=27 then  qqqq:=true;
end;

procedure TFrmMain.SpinEdit2KeyPress(Sender: TObject; var Key: Char);
begin
   if ord(key)=27 then  qqqq:=true;
end;

end.
